"""
 <Von Stiften und Musen>
 Eine neue Portierung fr Python, entstanden im Rahmen meiner Diplomarbeit.

 Klasse Bildschirm von SuM

 erste Vers: 21.01.2002
 Version...: 02.03.2003
 Status....: OK.
 Autor.....: i.linkweiler@gmx.de
"""

# Importiere benutze Module
import random, os.path, sys
import pygame, pygame.image, pygame.transform, pygame.sprite, pygame.draw
from pygame.locals import *
from math import *

from threading import *
import time

from comclass import *

# Teste, ob erweiterte Grafikimportfunktionen verfgbar sind, d.h. mehr mglich ist als standard BMP
if not pygame.image.get_extended():
    raise SystemExit, "Sorry, extended image module required"

# Versuche, pygame optional modules zu importieren
try:
    import pygame.font as font
except ImportError:
    print 'Warning, no fonts'
    font = None
try:
    import pygame.mixer
except ImportError:
    print 'Warning, no sound'
    pygame.mixer = None

try:
  _PATH=os.path.dirname(__file__)
except:
  _PATH=""

SCREENRECT     = Rect(0, 0, 640, 480)

# Konstanten
weiss=(255,255,255)
schwarz=(0,0,0)
rot=(255,0,0)
gruen=(0,255,0)
blau=(0,0,255)
gelb=(255,255,0)
grau=(100,100,100)

def list2str(l):
  r=""
  for i in l:
    if r != "": r=r+"|"
    if type(i)==type(" "):
      r=r+'"'+i+'"'
    else:
      r=r+str(i)
  return r

def str2list(s):
  r=[]
  for i in s.split("|"):
    if i[0]=='"':
      r.append(i[1:-1])
    elif i[0]=='(':
      r.append(eval(i))
    else:
      r.append(eval(i))
  return r

def load_image_key(name, colorkey=None):
    "intern: Lade ein Bild, colorkey ist transparente Farbe"
    fullname = os.path.join(_PATH,'data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', name
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

def load_image(file):
    "intern: Lade ein Bild"
    file = os.path.join(_PATH,'data', file)
    #file = os.path.join('data', file)
    try:
        surface = pygame.image.load(file)
    except pygame.error:
        raise SystemExit, 'Could not load image "%s" %s'%(file, pygame.get_error())
    return surface.convert()

def load_images(*files):
    "intern: Lade Bildliste"
    return [load_image(file) for file in files]


################################################
# Klasse Bildschirm
################################################

class Bildschirm:
  """
   Ein Bildschirm ist das Modell eines rechteckigen Bereiches auf dem
   angeschlossenen Computerbildschirm.
   Auf ihm kann mit Stiften gezeichnet werden. Zu diesem Zweck ist die 
   Zeichenebene auf dem Bildschirm mit einem Koordinatensystem versehen,
   dessen Ursprung sich in der oberen linken Ecke der Zeichenebene befindet
   und dessen Achsen horizontal nach rechts und vertikal nach unten 
   gerichtet sind. Die Einheit ist ein Pixel.
  """

  def screenrefresh(self):
      "intern: Bildschirm aktualisieren, damit auch im Interpreter der Redraw funktioniert."
      self.changed=0

      #self.eventloop()
      
      self.allsprites.update()
      self.screen.blit(self.background, (0,0))
      self.allsprites.draw(self.screen)
      
      pygame.display.flip()

  def eventloop(self):
    "intern: Abfrage der Systemereignisse Tastatur, Maus...."
    ev=pygame.event.poll()
    if ev.type<>NOEVENT:
      if ev.type==KEYDOWN:
        c=unicode(ev.unicode).encode("cp437", "replace")
        self.eingaben=self.eingaben+c
        # print c,
      elif ev.type==MOUSEMOTION:
        self.mauspos=ev.pos
      elif ev.type==MOUSEBUTTONDOWN:
        self.mausbutton=ev.button
        #print self.mausbutton
      elif ev.type==MOUSEBUTTONUP:
        self.mausbutton=0
        #print self.mausbutton
      elif str(ev.type)=="12":
        print "sys-exit"

        if self.server.srvactive==1:
          self.server.kill()
          self.beenden=1
        else:
          pygame.display.iconify() 
        #print str(ev.type)
        #sys.exit()
    else:
      #print "sleep"
      time.sleep(0.01)
      #print "wakeup"

    #print "*"
    if self.changed:
      self.screenrefresh()

  def subthread(self):
    """
    intern: Thread, aktualisiert 1*/sec das Ausgabefenster, damit auch im Interpreter
    der Redraw funktioniert.
    """

    while 1:
        try:
          if self.changed: self.screenrefresh()
        except:
          print "Fenster wurde geschlossen."
          raise SystemExit
          print "weg ist er..."

        time.sleep(1)
        # print "hi!"

  def ausfuehren(self,befehl):
    #print befehl
    par=str2list(befehl)  
    bef=par[0]
    r=""
    
    if bef=="plot":
      self.setpixel((par[1],par[2]),par[3])
    elif bef=="line":
      farbe=par[5]
      breite=par[6]
      self.drawline((par[1],par[2]),(par[3],par[4]),farbe,breite)
    elif bef=="text":
      self.text(par[1],(par[2],par[3]),par[4])
    elif bef=="ftext":
      self.fonttext(par[1],(par[2],par[3]),par[4],par[5],par[6],par[7])
    elif bef=="kreis":
      self.kreis(par[1],par[2],par[3],par[4])
    elif bef=="ende":
      self.raus=1

    elif bef=="clear":
      self.loescheAlles()
    elif bef=="setbg":
      self.setzeHintergrund(par[1])
    elif bef=="mouse":
      r=self.mausdaten()
    elif bef=="eingaben":
      r=self.sendeingaben()
    elif bef=="newsprite":
      print par[1]
      r=self.newsprite(par[1])
    elif bef=="setsprite":
      self.setsprite(par[1],par[2])
    elif bef=="dreheBis":
      self.dreheBis(par[1],par[2])
    elif bef=="testcol":
      r=self.findcollision(par[1],par[2])

      
    else:
      print "Befehl:",par  
      print "????unbekannter Befehl????"   
    return r
      
  def thread(self):
      "intern: starte den Redraw-Thread"
      self.st = Thread(target = self.subthread)   # dies...
      self.st.start()                        # ...ist schon alles!

  def callback(self,txt):
      #print "Server rec:",txt
      r=self.ausfuehren(txt)
      return r

  def startserver(self):
    "intern: starte den Server"
    print "START Server...",
    self.server = Server(self.callback)
    #print "OK."

  def wait4end(self):
    "intern: warte bis Server beendet...."
    while self.server.srvactive<3:
      self.eventloop()


  def stopserver(self):
    print "Sende STOP und warte auf Beendigung des Servers-Threads..."
    self.server.raus=1

    while self.server.srvactive<3:
      time.sleep(0.1)

    print "Server-Thread wurde beendet."

  def reset(self):
      self.changed=0
      self.raus=0
      self.beenden=0
      self.aktive_sprites=[]
      self.letzte_pos=(0,0)
      self.eingaben=""
      self.mauspos=(0,0)
      self.mausbutton=0
      self.active=0    

  def __init__(self,hintergrundbild=""):
      """
      nachher: Der Bildschirm ist initialisiert.
      'hintergrundbild' ist ein optionaler Dateiname einer Grafikdatei als Bildschirmhintergrund.    
      """

      self.reset()
      
      # Initialisiere pygame und ffne ein Fenster.
      pygame.init()
      # display mode setzen
      winstyle = 0 # |FULLSCREEN
      bestdepth = pygame.display.mode_ok(SCREENRECT.size, winstyle, 16)
      # Hintergrundbild laden
      self.screen = pygame.display.set_mode(SCREENRECT.size, winstyle, bestdepth)
   
      pygame.display.set_caption("Stifte und Muse")
      self.setzeHintergrund(hintergrundbild)

      self.aktive_sprites=[]
      self.allsprites=pygame.sprite.RenderPlain(self.aktive_sprites)

        
      self.eventloop()
      self.setzeHintergrund("sum.jpg")     
      try:
        self.snd=pygame.mixer.Sound("./data/sum.wav")
        self.snd.play()
      except:
        print "Kein Sound gefunden."
      
      self.eventloop()     
      #self.thread()
      self.changed=1


  def __del__(self):
      "intern: Destruktor, nur zur Sicherheit"
      print "del"
      self.ende()

  def breite(self):
      "liefert die breite der Zeichenebene"
      return 639
  def hoehe(self):
      "liefert die hoehe der Zeichenebene"
      return 479
  def loescheAlles(self):
      "loescht die Zeichenebene"
      self.background = pygame.Surface(SCREENRECT.size)
      self.screen.blit(self.background, (0,0))
      self.changed=1

  def setzeHintergrund(self,dateiname):
      "Lade einen Hintergrund und zeige diesen im Fenster."
      self.background = pygame.Surface(SCREENRECT.size)
      if dateiname<>"":
        bgdtile = load_image(dateiname)
        self.background = pygame.Surface(SCREENRECT.size)
        for x in range(0, SCREENRECT.width, bgdtile.get_width()):
            self.background.blit(bgdtile, (x, 0))

      self.screen.blit(self.background, (0,0))
      self.changed=1

  def ende(self):
      "intern: Ausgabefenster schlieen."
      self.st = 0
      pygame.quit()
      
  def gibFrei(self):
      "Das Ausgabefenster wird abgebaut und auf einen Tastendruck zum Programmende gewartet."
      print "*** SumServer wird beendet ***"
      self.ende()


  def mausstatus(self):
      "intern: true, wenn eine Maustaste gedrckt."
      if self.changed: self.eventloop()
      return self.mausbutton

  def mausposition(self):
      "intern: liefert Mausposition als tupel."
      if self.changed: self.eventloop()
      return self.mauspos

  def mausdaten(self):
      (mx,my)=self.mausposition()
      mz=self.mausstatus()
      return list2str(["maus",mx,my,mz])

  def sendeingaben(self):
      if self.changed: self.eventloop()
      r=list2str(["eingaben",self.eingaben])
      self.eingaben=""
      return r


  def setpixel(self,pos,farbe):
      "intern: Setze ein Pixel an Position pos:tupel in der Farbe farbe:3xtupel."
      if (pos[0]>=0) and (pos[1]>=0) and (pos[0]<640) and (pos[1]<480):
        self.screen.set_at(pos,farbe)
        self.background.set_at(pos,farbe)
        self.changed=1
      self.letzte_pos=pos

  def drawline(self,pos1,pos2,farbe,breite=1):
      "intern: Zeichnet eine Linie von pos1:tupel nach pos2:tupel in farbe:tupel und breite:int"
      pygame.draw.line(self.background, farbe, pos1, pos2, breite)
      pygame.draw.line(self.screen, farbe, pos1, pos2, breite)
      self.changed=1
  
  def kreis(self,pos,radius,farbe,fuellung=0):
      "intern: Zeichnet einen Kreis."
      if fuellung>0: fm=0
      else: fm=1
      pygame.draw.circle(self.background, farbe, pos, radius, fm)
      pygame.draw.circle(self.screen, farbe, pos, radius, fm)       
      self.changed=1

  def text(self,text,pos,farbe):
      "intern: Gibt Text aus."
      #font=pygame.font.Font("default.ttf",14)    
      font=pygame.font.Font(os.path.join(_PATH,"default.ttf"),14)    
      text=font.render(text,0,farbe)
      self.background.blit(text,pos)
      self.screen.blit(text,pos)  
      self.changed=1

  def fonttext(self,text,pos,farbe,font,groesse,flag=0):
      "intern: Gibt Text mit font aus."
      if font=="": font="default.ttf"
      font=pygame.font.Font(os.path.join(_PATH,font),groesse)
      #font=pygame.font.Font(font,groesse)
      if flag==1:
        font.set_bold(1)
      if flag==2:
        font.set_italic(1)
      if flag==4:
        font.set_underline(1)
      text=font.render(text,0,farbe)
      self.background.blit(text,pos)
      self.screen.blit(text,pos)
      self.changed=1

  def drawto(self,pos,farbe):
      "intern: zeichne linie bis zur Position pos:tupel, farbe:tripel"
      if self.letzte_pos==(0,0):
        self.letzte_pos=pos
      pygame.draw.line(self.background, farbe, self.letzte_pos, pos, 1)
      pygame.draw.line(self.screen, farbe, self.letzte_pos, pos, 1)
      self.letzte_pos=pos

  def collision(self,sprite1,sprite2):
      "intern: Teste Kollision zwischen zwei Sprites."
      hitbox = sprite1.rect.inflate(-5, -5)
      return hitbox.colliderect(sprite2.rect)

  def findcollision(self,sprite1id,sprite2id):
      "intern: Teste Kollision zwischen spriteid und allen anderen Sprites."
      for such in self.aktive_sprites:
        if such.id==sprite1id: sprite1=such
        if such.id==sprite2id: sprite2=such

      r=0
      hitbox = sprite1.rect.inflate(-5, -5)
      r=r+hitbox.colliderect(sprite2.rect)
      #print "COL=",sprite.id,test.id,hitbox.colliderect(test.rect)
      return list2str(["col",r])
      
  def newsprite(self,dateiname):
      "intern: Erzeige ein neues Sprite aus Bilddatei und fge es dem Bildschirm zu"
      sp=Sprite(dateiname,self)
      self.add_sprite(sp)
      self.changed=1
      return sp.id

  def setsprite(self,id,pos):
      "intern:Setzte das Sprite id an die Position pos"
      for sp in self.aktive_sprites:
        if sp.id == id:
          sp.setpos(pos)
      self.changed=1

  def dreheBis(self,id,winkel):
      "intern: Setzte das Sprite id an die Position pos"
      for sp in self.aktive_sprites:
        if sp.id == id:
          sp.dreheBis(winkel)
      self.changed=1

 
  def add_sprite(self,neues_sprite): 
      "intern: Fge ein Sprite in die Spriteliste ein."
      self.aktive_sprites.append(neues_sprite)

      self.allsprites=pygame.sprite.RenderPlain(self.aktive_sprites)
      self.changed=1


  def loesche_sprite(self,loeschsprite):
      "intern: loesche das angegebene Sprite"
      self.aktive_sprites.remove(loeschsprite)
      self.allsprites=pygame.sprite.RenderPlain(self.aktive_sprites)
      self.changed=1


################################################
# Klasse Sprite
################################################

class Sprite(pygame.sprite.Sprite):
    """
    Diese neue Klasse Sprite stellt eine auf der Ausgabeflche frei bewegbare Figur dar.
    """
  
    def __init__(self,bild,fenster):
        "identisch zu laden"
        self.laden(bild,fenster)
    
    def laden(self,bilddatei,fenster):
        """
        Vorbereiten des Sprites: Das Bild (jpg/bmp) wird geladen und das Sprite ist vorbereitet.
        bilddatei:Dateiname als string; fenster: zugehriger Bildschirm
        """
        
        pygame.sprite.Sprite.__init__(self) #call Sprite initializer
        self.image, self.rect = load_image_key(bilddatei,-1)
        self.oldimage = self.image
        self.rect = self.image.get_rect()
        self.pos=(random.randrange(5,500),40)
        self.move=(random.choice((1,5)),1)
        self.winkel=0
        self.fenster=fenster
        fenster.add_sprite(self)
        self.id=bilddatei+str(random.randint(1000,9999))

    def update(self):
        pass

    def bewegeBis(self,x,y):
        "Bewege das Sprite an die Position x,y: int"
        self.setpos((x,y))
        
    def hPosition(self):
        "liefert die aktuelle x-Position"
        return self.pos[0]
    def vPosition(self):
        "liefert die aktuelle y-Position"
        return self.pos[1]

    def setpos(self,pos):
        "intern: Setzte Sprite an Position pos: tupel"
        self.pos=pos
        # self.rect.midtop = self.pos    
        self.image=self.oldimage
        if self.winkel>0:
          winkel = self.winkel
          #PyGame-Bug workaround: 90er Winkel crashen!
          if winkel==90 or winkel==180 or winkel==270: winkel=winkel+1
          self.image=pygame.transform.rotate(self.image, winkel)
        if self.move[0]<0:
          self.image=pygame.transform.flip(self.image, 1, 0)
 
        self.rect = self.image.get_rect()       
        self.rect.center = self.pos  

    def dreheBis(self,neuwinkel):
        "Drehe das Spritebild auf den angegebenen Drehwinkel. neuwinkel:int"
        self.winkel=neuwinkel % 360
  
    def loeschen(self):
        "Entferne das Sprite vom Bildschirm."
        self.fenster.loesche_sprite(self)
        self.kill()
     
def main():
  "Testprogramm."
  bild=Bildschirm()
  while 1:
    bild.reset()
    bild.eventloop()
    bild.text("Stifte und Muse...",(10,10),blau)
    bild.startserver()
    bild.wait4end()
    bild.text("Ausgabe beendet.",(10,400),blau)
    bild.stopserver()

    print
    if bild.beenden: break

  bild.gibFrei()


# call the "main" function if running this script
if __name__ == '__main__': main()
