"""
 <Von Stiften und Musen>
 Eine neue Portierung fr Python, entstanden im Rahmen meiner Diplomarbeit.

 Klasse Bildschirm von SuM

 erste Vers: 21.01.2002
 Version...: 09.03.2003
 Status....: OK.
 Autor.....: i.linkweiler@gmx.de
"""

# Importiere benutze Module 
import random, os, sys
from math import *
import time
from comclass import *

global SCREEN
SCREEN=None

try:
  _PATH=os.path.dirname(__file__)
except:
  _PATH=""
  
# Konstanten
weiss=(255,255,255)
schwarz=(0,0,0)
rot=(255,0,0)
gruen=(0,255,0)
blau=(0,0,255)
gelb=(255,255,0)
grau=(100,100,100)

def list2str(l):
  r=""
  for i in l:
    if r != "": r=r+"|"
    if type(i)==type(" "):
      r=r+'"'+i+'"'
    else:
      r=r+str(i)
  return r

def str2list(s):
  r=[]
  for i in s.split("|"):
    if i[0]=='"':
      r.append(i[1:-1])
    elif i[0]=='(':
      r.append(eval(i))
    else:
      r.append(eval(i))
  return r

################################################
# Bildserver
################################################

class Bildserver:
  """
   derBild Server ist die Zentrale interne Komponente zur Darstellung der Grafiken
   und Kommunikation mit dem Betriebssystem.
   Dies geschieht durch Kommunikation mit der Bibliothek PyGame.
  """

  ### EXTERNE METHODEN ###
  def __init__(self,hintergrundbild=""):
      """
      Konstruktor, der Bildschirm wird initialisiert.
      'hintergrundbild' ist ein optionaler Dateiname einer Grafikdatei als Bildschirmhintergrund.    
      """

      global SCREEN
      if SCREEN != None: raise "Es darf nur ein Bildschirm verwendet werden."

      ok=0
      try:
        self.client=Client()
        ok=1
      except:
        self.startsum()
        while 1:
          versuch=0
          try:
            self.client=Client()
            break
          except:
            versuch=versuch+1
            print "*"
            time.sleep(0.5)
            if versuch>20:            
              print "Bevor mit Stiften und Mausen gearbeitet werden kann,"
              print "bitte erst das Programm <sumserver.py> starten."
              time.sleep(4)
              raise "Sumserver.py nicht aktiv."           
      self.loescheAlles()
      if hintergrundbild != "": self.setzeHintergrund(hintergrundbild)

      SCREEN=self

  def __del__(self):
      "intern: Destruktor, nur zur Sicherheit"
      self.ende()
      
  def breite(self):
      "liefert die breite der Zeichenebene"
      return 639

  def hoehe(self):
      "liefert die hoehe der Zeichenebene"
      return 479

  def loescheAlles(self):
      "loescht die Zeichenebene"   
      self.send(["clear"])

  def setzeHintergrund(self,dateiname):
      "Lade einen Hintergrund und zeige diesen im Fenster."
      if dateiname<>"":
        self.send(["setbg",dateiname])
      
  def gibFrei(self):
      "Das Ausgabefenster wird abgebaut."
      print "*** Programm beendet ***"
      self.ende()

  ### INTERNE METHODEN, NICHT ZUR NUTZUNG ###

  def mausstatus(self):
      "intern: Liefert den Status der Maustaste: 0/1=nicht/ist gedrueckt"
      r=str2list(self.request(["mouse"]))
      return r[3]

  def mauspos(self):
      "Liefert die Mausposition (x,y)"
      r=str2list(self.request(["mouse"]))
      return (r[1],r[2])

  def eingaben(self):
      "Liefert die letzten Tastatureingaben"
      r=str2list(self.request(["eingaben"]))
      return r[1]


  def ende(self):
      "intern: Ausgabefenster schlieen."
      self.client.close()
      time.sleep(1)
      global SCREEN
      SCREEN=None

  def startsum(self):
    "Versuche, den SuM-Serverprozess zustarten"
    try: # Windows....
      os.startfile(os.path.join(_PATH,"sumserver.pyw"))
    except:
      try:
        if sys.platform=="darwin": os.system("load python sumserver.py")
        else: os.system("python sumserver.py &")
        #os.spawnl(os.P_NOWAIT,f,".","sumserver.py")
      except:
        print "keine Startfunktion fr dieses OS."
    
    time.sleep(2)

  def send(self,cmds):
      "CLient sendet Befehle an Server"
      self.client.sendmsg(list2str(cmds))

  def request(self,t):
      "Client sendet t und wartet auf Anwort"
      return self.client.sendmsg(list2str(t))


  def setpixel(self,pos,farbe):
      "intern: Setze ein Pixel an Position pos:tupel in der Farbe farbe:3xtupel."
      if (pos[0]>=0) and (pos[1]>=0) and (pos[0]<640) and (pos[1]<480):
        self.send(["plot",pos[0],pos[1],farbe])

  def drawline(self,pos1,pos2,farbe,breite=1):
      "intern: Zeichnet eine Linie von pos1:tupel nach pos2:tupel in farbe:tupel und breite:int"
      self.send(["line",pos1[0],pos1[1],pos2[0],pos2[1],farbe,breite])
     
  def kreis(self,pos,radius,farbe,fuellung=0):
      "intern: Zeichnet einen Kreis."
      self.send(["kreis",pos,radius,farbe,fuellung])

  def text(self,text,pos,farbe):
      "intern: Gibt Text aus."
      self.send(["text",text,pos[0],pos[1],farbe])

  def fonttext(self,text,pos,farbe,font,groesse=10,flag=0):
      "intern: Gibt Text mit font aus."
      self.send(["ftext",text,pos[0],pos[1],farbe,font,groesse,flag])
      pass

  def drawto(self,pos,farbe):
      "intern: zeichne linie bis zur Position pos:tupel, farbe:tripel"
      pass

  def collision(self,sprite1,sprite2):
      "intern: Teste Kollision zwischen zwei Sprites."
      r=str2list(self.client.sendmsg(list2str(["testcol",sprite1,sprite2])))
      return r[1]
 
  def add_sprite(self,bilddatei): 
      "intern: Fge ein Sprite in die Spriteliste ein."
      print "Lade Sprite:",bilddatei
      return self.request(["newsprite",bilddatei])
      
  def loesche_sprite(self,loeschsprite):
      "intern: loesche das angegebene Sprite"
      pass
      
  def dreheBis(self,spid,winkel):
      self.client.sendmsg(list2str(["dreheBis",spid,winkel]))
      
  def setpos(self,spid,pos):
      "intern: Setzte Sprite an Position pos: tupel"
      self.client.sendmsg(list2str(["setsprite",spid,pos]))      
      
def main():
    "Testprogramm."
    bild=Bildserver()
    for i in range(20):
      farbe=(i*10,250-i*10,200)
      bild.text("Hallo, Bildschirmtest!",(10+i,10+i*16),farbe)      
      bild.drawline((i*30,10),(600-i*30,400),farbe,5)
    bild.kreis((320,200),100,gelb)
    bild.gibFrei()
        
# call the "main" function if running this script
if __name__ == '__main__': main()
